SystemOrganization addCategory: #'ICU-Core'!

ExternalStructure subclass: #ICUGeneralObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-Core'!

!ICUGeneralObject classSide methodsFor: 'as yet unclassified' stamp: 'jvds 6/12/2011 13:06'!
checkUErrorCode: anUErrorCode valueRC: rc

	"some kind of exception throwing should be here ..."
	anUErrorCode  failure ifTrue:[ self halt ].
	^rc value! !

!ICUGeneralObject classSide methodsFor: 'as yet unclassified' stamp: 'jvds 6/11/2011 23:14'!
fields

	^#(
		(nil 'ulong')
	)! !

ICUGeneralObject subclass: #UCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-Core'!

!UCalendar classSide methodsFor: 'api calls' stamp: 'jvds 6/12/2011 00:14'!
apiUCalOpenTimeZones: uErrorCode

	<cdecl:  UEnumerator* 'ucal_openTimeZones_48' (UErrorCode*) module: 'icuin48.dll'>
	^self externalCallFailed! !

ICUGeneralObject subclass: #UEnumerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-Core'!

!UEnumerator methodsFor: 'as yet unclassified' stamp: 'jvds 6/12/2011 00:14'!
apiUEnumClose: anEnumerator

	<cdecl: void 'uenum_close_48' (UEnumerator*) module: 'icuuc48.dll'>
	^self externalCallFailed! !

!UEnumerator methodsFor: 'as yet unclassified' stamp: 'jvds 6/12/2011 00:14'!
apiUEnumNext: anEnumerator with: aResultLength with: anErrorCode

"	const char* uenum_next	(	UEnumeration * 	en,
								int32_t * 	resultLength,
								UErrorCode * 	status 
	)"

	<cdecl: char* 'uenum_next_48' (UEnumerator* long* UErrorCode*) module: 'icuuc48.dll'>
	^self externalCallFailed! !

!UEnumerator methodsFor: 'as yet unclassified' stamp: 'jvds 6/12/2011 00:14'!
apiUEnumReset: anEnumerator with: anErrorCode

	<cdecl: void 'uenum_reset_48' (UEnumerator* UErrorCode*) module: 'icuuc48.dll'>
	^self externalCallFailed! !

!UEnumerator methodsFor: 'actions' stamp: 'jvds 6/12/2011 00:05'!
close

	self apiUEnumClose: self ! !

!UEnumerator methodsFor: 'enumerating' stamp: 'jvds 6/12/2011 00:06'!
collect: aBlock

	| nextItem result |
	
	result := OrderedCollection new.
	nextItem := self next.
	[ nextItem isNil ] whileFalse:[
		result add: (aBlock value: nextItem).
		nextItem := self next.
	].
	^result! !

!UEnumerator methodsFor: 'accessing' stamp: 'jvds 6/12/2011 13:07'!
next

	| result length status |
	
	result := self apiUEnumNext:  self with: (length := WordArray new: 1) with: (status := UErrorCode new).
	^self class checkUErrorCode: status valueRC: result! !

ExternalStructure subclass: #UErrorCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-Core'!

!UErrorCode classSide methodsFor: 'field definition' stamp: 'jvds 6/11/2011 22:54'!
fields

	^#(
		(status 'long')
	)! !

!UErrorCode methodsFor: 'testing' stamp: 'jvds 6/12/2011 13:06'!
failure

	^self status > 0! !

!UErrorCode methodsFor: 'accessing' stamp: 'jvds 6/11/2011 22:55'!
status

	^handle signedLongAt: 1! !

!UErrorCode methodsFor: 'testing' stamp: 'jvds 6/12/2011 12:59'!
success

	^self status <= 0! !
